/**
 * This file was auto-generated by openapi-typescript.
 * Do not make direct changes to the file.
 */


/** WithRequired type helpers */
type WithRequired<T, K extends keyof T> = T & { [P in K]-?: T[P] };

export interface paths {
  "/clients": {
    /**
     * Create new client
     * @description Create new client
     */
    post: operations["CreateClient"];
  };
  "/clients/{client-id}": {
    /**
     * Client data
     * @description Returns data about a client
     */
    get: operations["GetClient"];
  };
  "/users/{user-id}/sharings": {
    /**
     * User sharings
     * @description Returns list of sharings for user
     */
    get: operations["GetSharings"];
    /**
     * Create new sharing
     * @description Create new sharing
     */
    post: operations["CreateSharing"];
  };
  "/users/{user-id}/sharings/{sharing-id}": {
    /**
     * Fetch sharing
     * @description Fetch sharing
     */
    get: operations["GetSharing"];
    /**
     * Revoke an existing sharing
     * @description Revoke an existing sharing
     */
    put: operations["PutSharing"];
  };
  "/users/{user-id}/statuses": {
    /**
     * User status
     * @description Returns status of the specified kind for user
     */
    get: operations["GetStatusOfKind"];
  };
  "/statuses/{status-id}": {
    /**
     * Fetch status
     * @description Fetch status
     */
    get: operations["GetStatus"];
  };
}

export type webhooks = Record<string, never>;

export interface components {
  schemas: {
    /**
     * @example {
     *   "self": {
     *     "href": "https://example.com/foo"
     *   }
     * }
     */
    Links: {
      [key: string]: components["schemas"]["Link"];
    };
    /**
     * @example {
     *   "href": "https://example.com/foo"
     * }
     */
    Link: {
      href?: string;
      hreflang?: string;
      media?: string;
      title?: string;
      type?: string;
      deprecation?: string;
      profile?: string;
      name?: string;
    };
    ClientRequest: {
      /**
       * @description Client name for presentation
       * @example Något AB
       */
      humanFriendlyName: string;
      /**
       * Format: url
       * @description URL for logotype in SVG format.
       * @example https://example.com/some/path/logo.svg
       */
      logotypeUrl: string;
      /** @description Array of registered redirect URLs. */
      redirectUrls?: components["schemas"]["Url"][];
    };
    Client: WithRequired<{
      _links: components["schemas"]["Links"];
      /**
       * @description Client id
       * @example example-client-id
       */
      id: string;
      /**
       * Format: date-time
       * @description Timestamp for creation of client
       */
      created: string;
      /**
       * @description Token for client authentication
       * @example 69e8cc9a-9867-45f6-90d9-dd1c815e05a5
       */
      apiKey?: string;
    } & components["schemas"]["ClientRequest"], "_links" | "id" | "created">;
    /**
     * Format: url
     * @example https://example.com/home
     */
    Url: string;
    SharingRequest: {
      kind: components["schemas"]["Kind"];
      /**
       * @description Client ID of the sharing
       * @example example-client-id
       */
      clientId: string;
    };
    Sharing: WithRequired<{
      _links: components["schemas"]["Links"];
      /** @description ID of sharing */
      id: string;
      /**
       * @description User ID of the sharing
       * @example 199010102383
       */
      userId: string;
      /**
       * Format: date-time
       * @description Timestamp for creation of sharing
       */
      created: string;
      /**
       * Format: date-time
       * @description Timestamp for revocation of sharing.
       */
      revoked?: string;
    } & components["schemas"]["SharingRequest"], "_links" | "id" | "userId" | "created">;
    /** @description Array of sharings */
    Sharings: components["schemas"]["Sharing"][];
    Status: {
      _links: components["schemas"]["Links"];
      kind: components["schemas"]["Kind"];
      data: {
        /**
         * Format: date
         * @description Date of inskrivning.
         * @example "2023-01-11T00:00:00.000Z"
         */
        date?: string;
        /**
         * @description Current status.
         * @enum {string}
         */
        status?: "inskriven" | "unknown";
      };
      /**
       * Format: date-time
       * @description Timestamp for creation of response
       * @example "2023-07-21T17:32:28.000Z"
       */
      timestamp: string;
    };
    /** @description Array of statuses */
    Statuses: components["schemas"]["Status"][];
    /**
     * @description Kind of status
     * @example INSKRIVNINGSSTATUS
     * @enum {string}
     */
    Kind: "INSKRIVNINGSSTATUS";
    Error: {
      /**
       * @description Status code
       * @example 404
       */
      status: number;
      /**
       * @description Error type
       * @example Not Found
       */
      error: string;
      /**
       * @description Error message
       * @example Requested resource does not exist
       */
      message?: string;
    };
  };
  responses: {
    /** @description Unauthorized */
    Unauthorized: {
      content: {
        "application/json": components["schemas"]["Error"];
      };
    };
    /** @description Forbidden */
    Forbidden: {
      content: {
        "application/json": components["schemas"]["Error"];
      };
    };
    /** @description Not Found */
    NotFound: {
      content: {
        "application/json": components["schemas"]["Error"];
      };
    };
  };
  parameters: never;
  requestBodies: never;
  headers: never;
  pathItems: never;
}

export type $defs = Record<string, never>;

export type external = Record<string, never>;

export interface operations {

  /**
   * Create new client
   * @description Create new client
   */
  CreateClient: {
    /** @description Information about the client to be created */
    requestBody: {
      content: {
        "application/json": components["schemas"]["ClientRequest"];
      };
    };
    responses: {
      /** @description Created */
      201: {
        headers: {
          /** @description The location of the created resource */
          "Content-Location"?: string;
        };
        content: {
          "application/json": components["schemas"]["Client"];
        };
      };
      /** @description Bad Request - for example invalid request body (missing mandatory properties, invalid combination of properties) */
      400: {
        content: {
          "application/json": components["schemas"]["Error"];
        };
      };
      401: components["responses"]["Unauthorized"];
      403: components["responses"]["Forbidden"];
    };
  };
  /**
   * Client data
   * @description Returns data about a client
   */
  GetClient: {
    parameters: {
      path: {
        /** @description ID of client to return */
        "client-id": string;
      };
    };
    responses: {
      /** @description OK */
      200: {
        content: {
          "application/json": components["schemas"]["Client"];
        };
      };
      401: components["responses"]["Unauthorized"];
      403: components["responses"]["Forbidden"];
      404: components["responses"]["NotFound"];
    };
  };
  /**
   * User sharings
   * @description Returns list of sharings for user
   */
  GetSharings: {
    parameters: {
      path: {
        /** @description ID of user */
        "user-id": string;
      };
    };
    responses: {
      /** @description OK */
      200: {
        content: {
          "application/json": components["schemas"]["Sharings"];
        };
      };
      401: components["responses"]["Unauthorized"];
      403: components["responses"]["Forbidden"];
      404: components["responses"]["NotFound"];
    };
  };
  /**
   * Create new sharing
   * @description Create new sharing
   */
  CreateSharing: {
    parameters: {
      path: {
        /** @description ID of user */
        "user-id": string;
      };
    };
    /** @description Sharing request */
    requestBody: {
      content: {
        "application/json": components["schemas"]["SharingRequest"];
      };
    };
    responses: {
      /** @description Created */
      201: {
        headers: {
          /** @description The location of the created sharing */
          "Content-Location"?: string;
        };
        content: {
          "application/json": components["schemas"]["Sharing"];
        };
      };
      /** @description Bad Request - for example invalid request body (missing mandatory properties, invalid combination of properties) */
      400: {
        content: {
          "application/json": components["schemas"]["Error"];
        };
      };
      401: components["responses"]["Unauthorized"];
      403: components["responses"]["Forbidden"];
      404: components["responses"]["NotFound"];
    };
  };
  /**
   * Fetch sharing
   * @description Fetch sharing
   */
  GetSharing: {
    parameters: {
      path: {
        /** @description ID of user */
        "user-id": string;
        /** @description ID of sharing */
        "sharing-id": string;
      };
    };
    responses: {
      /** @description OK */
      200: {
        content: {
          "application/json": components["schemas"]["Sharing"];
        };
      };
      401: components["responses"]["Unauthorized"];
      403: components["responses"]["Forbidden"];
      404: components["responses"]["NotFound"];
    };
  };
  /**
   * Revoke an existing sharing
   * @description Revoke an existing sharing
   */
  PutSharing: {
    parameters: {
      path: {
        /** @description ID of user */
        "user-id": string;
        /** @description ID of sharing */
        "sharing-id": string;
      };
    };
    /** @description The revoked sharing */
    requestBody?: {
      content: {
        "application/json": components["schemas"]["Sharing"];
      };
    };
    responses: {
      /** @description No Content */
      204: {
        headers: {
          /** @description The location of the updated sharing */
          "Content-Location"?: string;
        };
        content: never;
      };
      /** @description Bad Request - for example invalid request body (missing mandatory properties, invalid combination of properties) */
      400: {
        content: {
          "application/json": components["schemas"]["Error"];
        };
      };
      401: components["responses"]["Unauthorized"];
      403: components["responses"]["Forbidden"];
      404: components["responses"]["NotFound"];
      /** @description Conflict - only allowed to add 'revoked' property if not already present */
      409: {
        content: {
          "application/json": components["schemas"]["Error"];
        };
      };
    };
  };
  /**
   * User status
   * @description Returns status of the specified kind for user
   */
  GetStatusOfKind: {
    parameters: {
      query: {
        /** @description kind of status */
        kind: components["schemas"]["Kind"];
      };
      path: {
        /** @description ID of user */
        "user-id": string;
      };
    };
    responses: {
      /** @description OK */
      200: {
        content: {
          "application/json": components["schemas"]["Statuses"];
        };
      };
      401: components["responses"]["Unauthorized"];
      403: components["responses"]["Forbidden"];
    };
  };
  /**
   * Fetch status
   * @description Fetch status
   */
  GetStatus: {
    parameters: {
      path: {
        /** @description ID of status */
        "status-id": string;
      };
    };
    responses: {
      /** @description OK */
      200: {
        content: {
          "application/json": components["schemas"]["Status"];
        };
      };
      401: components["responses"]["Unauthorized"];
      403: components["responses"]["Forbidden"];
      404: components["responses"]["NotFound"];
    };
  };
}
